import java.util.Random;
import java.util.concurrent.locks.ReentrantLock;

class Bank{
  int slots;
  int[] av;
  ReentrantLock[] lv;
  public Bank(int n) 
	{ 
		int j;
		slots = n; 
		av=new int[slots];
		lv=new ReentrantLock[slots];
		for(j=0; j<slots; j++)
		{
			av[j]=100;
			lv[j]=new ReentrantLock();
		}
	}

  public void lock(int i) { lv[i].lock(); }
  public void unlock(int i) { lv[i].unlock(); }

  public void put(int i,int a) {
		av[i]+=a;
  }

  public void take(int i,int a) {
		av[i]-=a;
  }

	public int query(int i)
	{
		return av[i];
	}

	public int slots() { return slots; }

}

class Mover implements Runnable {
  Bank b;
  public Mover(Bank b) {
    this.b = b;
  }
  public void run() {
	Random rand = new Random();
	int slots=b.slots();
	int f;
	int t;
	while(true) 
	{ 
		f=rand.nextInt(slots); // get one
		while((t=rand.nextInt(slots))==f); // get a distinct other
		if (f<t)
		{
			b.lock(f);
			b.lock(t);
		}
		else
		{
			b.lock(t);
			b.lock(f);
		}
		b.take(f,10);
		b.put(t,10);
		b.unlock(f);
		b.unlock(t);
//		System.out.println("Moved");
	}
   }
}

class Adder implements Runnable {
  Bank b;
  public Adder(Bank b) {
    this.b = b;
  }
  public void run() {
	Random rand = new Random();
	int slots=b.slots();
	int sum, i, lsum=1000;
	while(true) 
	{ 
		sum=0;
		for (i=0; i<slots; i++) b.lock(i);
		for (i=0; i<slots; i++)
		{
			sum+=b.query(i);
			b.unlock(i);
		}
		if (lsum!=sum) System.out.println("Total "+sum);
		lsum=sum;
	}
   }
}



class Main {
	public static void main(String[] args) {
		int N = 10; // Number of accounts
		Bank b = new Bank(N);
		Mover m = new Mover(b);
		Adder c = new Adder(b);

		new Thread(m).start();
		new Thread(c).start();
	}
}

